﻿    // See https://aka.ms/new-console-template for more information
    using System.Text.Json;
    using System.Text;
    using Azure.Messaging.ServiceBus;
    using Microsoft.Azure.Amqp;


    // Configuration
    string connectionString = "Endpoint=sb://<MyServiceName>.servicebus.windows.net/;SharedAccessKeyName=<MyPolicy>;SharedAccessKey=<ClientId>;EntityPath=<MyTopic>";
    string topicName = "<MyTopic>";
    string subscriptionName = "<SubscriptionName>";

    Console.WriteLine("Publisher:");
    // since ServiceBusClient implements IAsyncDisposable we create it with "await using"
    await using var client = new ServiceBusClient(connectionString);

    // create the sender that we will use to send to our topic
    ServiceBusSender sender = client.CreateSender(topicName);

    // create a message that we can send. UTF-8 encoding is used when providing a string.
    var bodyMessage = "Hello world message 1: " + DateTime.UtcNow;

    var message = new ServiceBusMessage
    {
        SessionId = "1",
        Body = new BinaryData(bodyMessage)
    };

    Console.WriteLine("  Sending message: " + bodyMessage + " ------> SessionId: " + message.SessionId);

    // send the message
    await sender.SendMessageAsync(message);
    Console.WriteLine("  Message Sent");

    System.Threading.Thread.Sleep(2000);

    bodyMessage = "Hello world message 2: " + DateTime.UtcNow;

    message = new ServiceBusMessage
    {
        SessionId = "1",
        Body = new BinaryData(bodyMessage)
    };

    Console.WriteLine("  Sending message: " + bodyMessage + " ------> SessionId: " + message.SessionId);

    // send the message
    await sender.SendMessageAsync(message);
    Console.WriteLine("  Message Sent");

    Console.WriteLine("");

    Console.WriteLine("Consumer:");

    // create a receiver for our subscription that we can use to receive the message
    ServiceBusReceiver receiver = client.CreateReceiver(topicName, subscriptionName);

    // the received message is a different type as it contains some service set properties
    ServiceBusReceivedMessage receivedMessage = await receiver.ReceiveMessageAsync();

    // get the message body as a string
    string body = receivedMessage.Body.ToString();
    Console.WriteLine("  Received ------> " + body + " ------> SessionId: " + receivedMessage.SessionId);

    // the received message is a different type as it contains some service set properties
    receivedMessage = await receiver.ReceiveMessageAsync();

    // get the message body as a string
    body = receivedMessage.Body.ToString();
    Console.WriteLine("  Received ------> " + body + " ------> SessionId: " + receivedMessage.SessionId);